"""organisatoin and url db

Revision ID: a420a842a5b6
Revises: 58ce9901de10
Create Date: 2022-04-08 14:36:58.109107+02:00

"""
import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "a420a842a5b6"
down_revision = "58ce9901de10"
branch_labels = None
depends_on = None


def upgrade():
    """Upgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "url",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("url", sa.String(), nullable=False),
        sa.Column("primary", sa.Boolean(), nullable=True),
        sa.Column("organization_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["organization_id"],
            ["organization.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_url_sid"), "url", ["sid"], unique=False)
    op.create_index(op.f("ix_url_url"), "url", ["url"], unique=True)

    op.drop_index("ix_organization_url", table_name="organization")

    op.execute(
        'insert into url ("uuid", "primary", "organization_id", "url") '
        'select gen_random_uuid() as uuid, true as "primary", org2.sid as organization_id, '
        "case "
        "when (select count(org1.sid) from organization org1 where org1.url = org2.url) > 1 "
        " then CONCAT(org2.url, '?org_id=', org2.sid) "
        " else org2.url "
        "end as url "
        "from organization org2"
    )

    op.drop_column("organization", "url")
    # ### end Alembic commands ###


def downgrade():
    """Downgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "organization",
        sa.Column("url", sa.VARCHAR(), autoincrement=False, nullable=False),
    )

    op.drop_constraint(None, "organization", type_="unique")
    op.create_index("ix_organization_url", "organization", ["url"], unique=False)

    op.create_unique_constraint(
        "uc_slug_organization", "form_management", ["slug", "organization_sid"]
    )
    op.create_unique_constraint(
        "uc_name_organization", "form_management", ["name", "organization_sid"]
    )

    op.drop_index(op.f("ix_url_url"), table_name="url")
    op.drop_index(op.f("ix_url_sid"), table_name="url")
    op.drop_table("url")
    # ### end Alembic commands ###
